/**
 * Here are some reasons to stop the user from compiling
 * Probably more will come as more things are added
 */
// TODO need to make an error datatype that combines these into a single error
// TODO Only a few of these are used atm ...
export class CompilerError extends Error {
}
// Base Class for parse-time errors
export class ParseError extends CompilerError {
    /**
     * @param message - Reason
     */
    constructor(message) {
        super(message);
    }
}
// Reference specific section(s) of code
export class SyntaxError extends ParseError {
    ctx;
    tokens;
    /**
     * @param message - Reason
     * @param tokens - Location in code
     * @param ctx - parser context
     */
    constructor(message, tokens, ctx) {
        super(message);
        this.ctx = ctx;
        this.ctx = ctx;
        if (!(tokens instanceof Array))
            tokens = [tokens];
        this.tokens = tokens;
    }
    /**
     * Remove adjacent duplicate tokens
     * @returns modified this.tokens
     */
    dedupTokens() {
        if (this.tokens.length === 0)
            return [];
        let p;
        this.tokens = this.tokens.filter(t => t && t !== p ? (p = t) : false);
        return this.tokens;
    }
}
export class TypeError extends SyntaxError {
    vs;
    expected;
    /**
     * @constructor
     * @param message Reason
     * @param tokens location in code
     * @param vs offending value/expression
     * @param expected type expected
     * @param ctx parser context
     */
    constructor(message, tokens, vs, expected, ctx) {
        super(message, tokens, ctx);
        this.vs = vs;
        this.expected = expected;
    }
}
export class StackTypeError extends SyntaxError {
    values;
    expected;
    constructor(message, tokens, values, expected, ctx) {
        super(message, tokens, ctx);
        this.values = values;
        this.expected = expected;
    }
}
// TODO more, better errors which can get displayed more readably with additional info
//# sourceMappingURL=error.js.map