/* eslint-disable */

// const inline = require('../dist/tools/inline');

// Load WAT source
const fs = require('fs');

const fname = 'tmp.wasm';
const bin = fs.readFileSync(fname);
console.log('bin:', bin);
const valid = WebAssembly.validate(bin);
console.log('valid:', valid);

// WASM Environment
const env = {
	js: {
		mem: new WebAssembly.Memory({ initial: 1 }),
		eval: function (len, ptr) {
			// Read wasm string from memory
			const bytes = new Uint8Array(env.js.mem.buffer, ptr, len);
			const str = new TextDecoder('utf8').decode(bytes);

			// Execute the string as JS Code lmao
			eval(str);
		},
		'console.log': console.log,
		'Math.random': Math.random.bind(Math),
	},
};

// Invoke wasm export
WebAssembly.instantiate(bin, env).then(mod => {
	// mod.instance.exports.main();

	// let start = performance.now();
	// mod.instance.exports.no_swap();
	// console.log('no swap: ', performance.now() - start);

	// start = performance.now();
	// mod.instance.exports.swap();
	// console.log('swap: ', performance.now() - start);

	// // Test fac
	// for (let i = 0n; i < 10n; i++)
	// 	console.log(mod.instance.exports.fac(i));

	// // Test abs
	// for (let i = -4; i < 5; i++)
	// 	console.log(mod.instance.exports.abs(i));


	console.log(0, '=>', mod.instance.exports.test(0));
	console.log(1, '=>', mod.instance.exports.test(1));
	console.log(2, '=>', mod.instance.exports.test(2));
	console.log(3, '=>', mod.instance.exports.test(3));
	console.log(4, '=>', mod.instance.exports.test(4));
	console.log(5, '=>', mod.instance.exports.test(5));

}).catch(e => console.error(e));