
// For browser version this should be a url
const pathPrefix = import.meta.url.slice(0, -8);
export default {
    // These are generated via the build.js script, do not edit directly!
    'bits' : {
        src: "\"./lang.phs\" require use\n\n# Left shift\n((I32 I32): 1 ) (: \"i32.shl\" asm ) $global.<< fun\n((I64 I64): 1 ) (: \"i64.shl\" asm ) $global.<< fun\n\n# Right shift\n((I32 I32): 1 ) (: \"i32.shr_s\" asm ) $global.>> fun\n((I64 I64): 1 ) (: \"i64.shr_s\" asm ) $global.>> fun\n((I32 I32): 1 ) (: \"i32.shr_u\" asm ) $global.>>> fun\n((I64 I64): 1 ) (: \"i64.shr_u\" asm ) $global.>>> fun\n\n# Bitwise and\n((I32 I32): 1 ) (: \"i32.and\" asm ) $and fun\n((I64 I64): 1 ) (: \"i64.and\" asm ) $and fun\n\n# Bitwise or\n((I32 I32): 1 ) (: \"i32.or\" asm ) $or fun\n((I64 I64): 1 ) (: \"i64.or\" asm ) $or fun\n\n# Bitwise xor\n((I32 I32): 1 ) (: \"i32.xor\" asm ) $xor fun\n((I64 I64): 1 ) (: \"i64.xor\" asm ) $xor fun\n\n# Left rotate\n((I32 I32): 1 ) (: \"i32.rotl\" asm ) $rotl fun\n((I64 I64): 1 ) (: \"i64.rotl\" asm ) $rotl fun\n\n# Right rotate\n((I32 I32): 1 ) (: \"i32.rotr\" asm ) $rotr fun\n((I64 I64): 1 ) (: \"i64.rotr\" asm ) $rotr fun\n\n# Count leading zeros\n((I32): 1 ) (: \"i32.clz\" asm ) $clz fun\n((I64): 1 ) (: \"i64.clz\" asm ) $clz fun\n\n# Count trailing zeros\n((I32): 1 ) (: \"i32.ctz\" asm ) $ctz fun\n((I64): 1 ) (: \"i64.ctz\" asm ) $ctz fun\n\n# Population count (number of 1 bits in binary repr.)\n((I32): 1 ) (: \"i32.popcnt\" asm ) $popcnt fun\n((I64): 1 ) (: \"i64.popcnt\" asm ) $popcnt fun\n\n# Reinterpret bits into different type\n((I32): 1 ) (: \"f32.reinterpret_i32\" asm ) $reinterpret fun\n((I64): 1 ) (: \"f64.reinterpret_i64\" asm ) $reinterpret fun\n((F32): 1 ) (: \"i32.reinterpret_f32\" asm ) $reinterpret fun\n((F64): 1 ) (: \"i64.reinterpret_f64\" asm ) $reinterpret fun\n\n# Extend\n((I32): 1 ) (: \"i32.extend8_s\" asm ) $sign_extend8 =\n((I64): 1 ) (: \"i64.extend8_s\" asm ) $sign_extend8 =\n((I32): 1 ) (: \"i32.extend16_s\" asm ) $sign_extend16 =\n((I64): 1 ) (: \"i64.extend16_s\" asm ) $sign_extend16 =\n((I64): 1 ) (: \"i64.extend32_s\" asm ) $sign_extend32 =\n\n# Cast U32 to U64\n((I32)(I64): \"i64.extend_i32_u\" asm ) $zero_extend =",
        path: pathPrefix + 'bits.phs',
    },
    'either' : {
        src: "\"./list.phs\" require use\n\n# Contains either left or right types\n(: ( $TLeft $TRight ) =\n    (:  TLeft class $Left =\n        TRight class $Right =\n    ) enum $EitherType =\n    TLeft $EitherType.TLeft =\n    TRight $EitherType.TRight =\n    EitherType\n) $Either =\n\n# Some broad types\nAny Any Either $AnyEither =\n(Any) Any Arrow Syntax:Macro | $Invokeable =\n\n# Invokes different macro depending on which side is populated\n(( AnyEither Invokeable Invokeable ): 1)\n(:\n    ( $e $l $r ) =\n    e type $Te =\n    (   Te.Left (: l )\n        Te.Right (: r )\n    ) match\n) $either fun\n\n# Returns 1 if it's left member, 0 otherwise\n((AnyEither): 1) (:\n    dup type $EitherType =\n    (: pop 1 ) (: pop 0 ) either\n) $is_left fun\n\n# Returns 1 if it's right member, 0 otherwise\n((AnyEither): 1) (:\n    dup type $EitherType =\n    (: pop 0 ) (: pop 1 ) either\n) $is_right fun\n\n# Keep only the left elements of a list\n((AnyEither List): 1 ) (:\n    dup type $ListType =\n    (: is_left ) ListType.filter\n) $lefts fun\n\n# Keep only the right elements of a list\n((AnyEither List): 1 ) (:\n    dup type $ListType =\n    (: is_right ) ListType.filter\n) $rights fun\n",
        path: pathPrefix + 'either.phs',
    },
    'io' : {
        src: "\"./lang.phs\"    require use\n\"./monad.phs\"   require \"Monad\" \"\" use_some\n\"./str.phs\"     require \"StaticStr\" \"\" use_some\n\n# Deprecated\n\n# IO extends class monad\n$Monad ~ class $IO =\n\n# Define print for numbers\n((Any IO  __Scalar): 1 )\n(: ( $io $v ) =\n    io v ( io type v type ) ( io type ) Arrow ( \"js\" \"console.log\" ) import @\n) $print fun\n\n# Define print for strings\n((Any IO  StaticStr): 1 )\n(: ( $io $str ) =\n    io str ( io type StaticStr ) ( io type ) Arrow ( \"js\" \"logStr\" ) import @\n) $print fun",
        path: pathPrefix + 'io.phs',
    },
    'lang' : {
        src: "# Empty type\n() type $Unit =\nNever $Void =\n\n# Stack\n(: $_ = ) $pop =\t\t\t\t# Pop value\n(: $v = v v ) $dup =\t\t\t# Duplicate value\n(: ( $a $b ) = $b ~ $a ~ ) $swap = # swap values\n\n# Booleans\n1 $true  =\n0 $false =\n\n# Logic\n((I32): 1 ) (: false == ) $global.! fun\n\n# And\n# Notice the @ for short-circuit\n(: true ) (: pop pop false ) $global.&& fun\n(: swap ) (: swap pop @ ) $global.&& fun\n\n# Or\n(: true ) (: pop pop false ) $global.|| fun\n(: swap pop ) (: swap pop @ ) $global.|| fun\n(: pop ) (: pop @ ) $global.|| fun\n\n##\n# Cast a value of one type to another type\n# <value> <type> cast\n##\n\n# No need to cast if already same type as target\n# Maybe remove classes?\n(: swap type == ) (: pop ) $cast fun\n\n# Cast to I32\n((I64 Syntax:Type): I32 == ) (: pop \"i32.wrap_i64\" asm ) $cast fun\n((F32 Syntax:Type): I32 == ) (: pop \"i32.trunc_f32_s\" asm ) $cast fun\n((F64 Syntax:Type): I32 == ) (: pop \"i32.trunc_f64_s\" asm ) $cast fun\n\n# Cast to I64\n((I32 Syntax:Type): I64 == ) (: pop \"i64.extend_i32_s\" asm ) $cast fun\n((F32 Syntax:Type): I64 == ) (: pop \"i64.trunc_f32_s\" asm ) $cast fun\n((F64 Syntax:Type): I64 == ) (: pop \"i64.trunc_f64_s\" asm ) $cast fun\n\n# Cast to F32\n((I32 Syntax:Type): F32 == ) (: pop \"f32.convert_i32_s\" asm ) $cast fun\n((I64 Syntax:Type): F32 == ) (: pop \"f32.convert_i64_s\" asm ) $cast fun\n((F64 Syntax:Type): F32 == ) (: pop \"f32.demote_f64\" asm ) $cast fun\n\n# Cast to F64\n((I32 Syntax:Type): F64 == ) (: pop \"f64.convert_i32_s\" asm ) $cast fun\n((I64 Syntax:Type): F64 == ) (: pop \"f64.convert_i64_s\" asm ) $cast fun\n((F32 Syntax:Type): F64 == ) (: pop \"f64.promote_f32\" asm ) $cast fun\n\n# Perform promotion\n((I64 F64): 1 ) (: swap F64 cast swap ) $__promote fun\n((F64 I64): 1 ) (: F64 cast ) $__promote fun\n((I64 F32): 1 ) (: swap F32 cast swap ) $__promote fun\n((F32 I64): 1 ) (: F32 cast ) $__promote fun\n((I32 I64): 1 ) (: swap I64 cast swap ) $__promote fun\n((I64 I32): 1 ) (: I64 cast ) $__promote fun\n((I32 F32): 1 ) (: swap F32 cast swap ) $__promote fun\n((F32 I32): 1 ) (: F32 cast ) $__promote fun\n((F32 F64): 1 ) (: swap F64 cast swap ) $__promote fun\n((F64 F32): 1 ) (: F64 cast ) $__promote fun\n((I32 F64): 1 ) (: swap F64 cast swap ) $__promote fun\n((F64 I32): 1 ) (: F64 cast ) $__promote fun\n\n# Condition for numeric type promotions\nI32 I64 | F32 F64 | | $__Scalar =\n((__Scalar __Scalar): ( $a $b ) =\n\ta type b type == !\n) $__can_promote =\n\n# Do we know at compile time that the value is a 0/1/-1\n(: 1 ) (: 0 ) $__is_0 fun\n((I32): is_const ) (: \"i32.eqz\" asm ) $__is_0 fun\n((I64): is_const ) (: \"i64.eqz\" asm ) $__is_0 fun\n((F32): is_const ) (: 0.0f \"f32.eq\" asm ) $__is_0 fun\n((F64): is_const ) (: 0.0l \"f64.eq\" asm ) $__is_0 fun\n(: 1 ) (: 0 ) $__is_1 fun\n((I32): is_const ) (: 1 == ) $__is_1 fun\n((I64): is_const ) (: 1L == ) $__is_1 fun\n((F32): is_const ) (: 1.0f == ) $__is_1 fun\n((F64): is_const ) (: 1.0l == ) $__is_1 fun\n(: 1 ) (: 0 ) $__is_neg1 fun\n((I32): is_const ) (: -1 == ) $__is_neg1 fun\n((I64): is_const ) (: -1L == ) $__is_neg1 fun\n((F32): is_const ) (: -1.0f == ) $__is_neg1 fun\n((F64): is_const ) (: -1.0l == ) $__is_neg1 fun\n(: 1 ) (: 0 ) $__is_2 fun\n((I32): is_const ) (: 2 == ) $__is_2 fun\n((I64): is_const ) (: 2L == ) $__is_2 fun\n\n\n##\n# Operator ==\n##\n\n((I32 I32): __is_0 ) (: pop \"i32.eqz\" asm ) $global.== fun\n((I32 I32): pop __is_0 ) (: swap pop \"i32.eqz\" asm ) $global.== fun\n((I64 I64): __is_0 ) (: pop \"i64.eqz\" asm ) $global.== fun\n((I64 I64): pop __is_0 ) (: swap pop \"i64.eqz\" asm ) $global.== fun\n\n((I32 I64): 1 ) (: swap I64 cast swap == ) $global.== fun\n((I64 I32): 1 ) (: I64 cast == ) $global.== fun\n((F32 F64): 1 ) (: swap F64 cast swap == ) $global.== fun\n((F64 F32): 1 ) (: F64 cast == ) $global.== fun\n\n((Syntax:Type Syntax:Type): 1 ) (: __typecheck ) $global.== fun\n\n##\n# Operator !=\n##\n\n# Make != also work on untyped values\n(: true ) (: == ! ) $global.!= fun\n\n# Compare of same type\n((I32 I32): 1 ) (: \"i32.ne_s\" asm ) $global.!= fun\n((I64 I64): 1 ) (: \"i64.ne_s\" asm ) $global.!= fun\n((F32 F32): 1 ) (: \"f32.ne\" asm ) $global.!= fun\n((F64 F64): 1 ) (: \"f64.ne\" asm ) $global.!= fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote != ) $global.!= fun\n\n##\n# Operator +\n##\n\n# Add values of same type\n((I32 I32): 1 ) (: \"i32.add\" asm ) $global.+ fun\n((I64 I64): 1 ) (: \"i64.add\" asm ) $global.+ fun\n((F32 F32): 1 ) (: \"f32.add\" asm ) $global.+ fun\n((F64 F64): 1 ) (: \"f64.add\" asm ) $global.+ fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote + ) $global.+ fun\n\n# Optimization when one of the values is known to be zero the result is the other value\n(: pop $a = a __is_0 ) (: swap pop ) $global.+ fun\n(: __is_0 ) (: pop ) $global.+ fun\n\n##\n# Operator -\n##\n\n# Negation\n((I32): 1 ) (: $n = 0 n \"i32.sub\" asm ) $neg fun\n((I64): 1 ) (: $n = 0L n \"i64.sub\" asm ) $neg fun\n((F32): 1 ) (: \"f32.neg\" asm ) $neg fun\n((F64): 1 ) (: \"f64.neg\" asm ) $neg fun\n\n# Subtract values of same type\n((I32 I32): 1 ) (: \"i32.sub\" asm ) $global.- fun\n((I64 I64): 1 ) (: \"i64.sub\" asm ) $global.- fun\n((F32 F32): 1 ) (: \"f32.sub\" asm ) $global.- fun\n((F64 F64): 1 ) (: \"f64.sub\" asm ) $global.- fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote - ) $global.- fun\n\n# Optimization when one of the values is known to be zero\n(: pop $a = a __is_0 ) (: swap pop neg ) $global.- fun\n(: __is_0 ) (: pop ) $global.- fun\n\n##\n# Operator *\n##\n\n# Mul values of same type\n((I32 I32): 1 ) (: \"i32.mul\" asm ) $global.* fun\n((I64 I64): 1 ) (: \"i64.mul\" asm ) $global.* fun\n((F32 F32): 1 ) (: \"f32.mul\" asm ) $global.* fun\n((F64 F64): 1 ) (: \"f64.mul\" asm ) $global.* fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote * ) $global.* fun\n\n# Optimization for identity property of multiplication\n(: pop __is_1 ) (: swap pop ) $global.* fun\n(: __is_1 ) (: pop ) $global.* fun\n\n# Negation\n(: pop __is_neg1 ) (: swap pop neg ) $global.* fun\n(: __is_neg1 ) (: pop neg ) $global.* fun\n\n# Optimization for zero property of multiplication\n# TODO? maybe make the zero the same type?\n(: pop __is_0 ) (: pop pop 0 ) $global.* fun\n(: __is_0 ) (: pop pop 0 ) $global.* fun\n\n# TODO optimize to shl\n\n##\n# Operator /\n##\n\n# Div values of same type\n((I32 I32): 1 ) (: \"i32.div_s\" asm ) $global./ fun\n((I64 I64): 1 ) (: \"i64.div_s\" asm ) $global./ fun\n((F32 F32): 1 ) (: \"f32.div\" asm ) $global./ fun\n((F64 F64): 1 ) (: \"f64.div\" asm ) $global./ fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote / ) $global./ fun\n\n# Divide by 1 is identity\n(: __is_1 ) (: pop ) $global./ fun\n\n# 0 divided by anything is 0\n(: pop __is_0 ) (: pop ) $global./ fun\n\n##\n# Operator %\n##\n\n# Remainder values of same type\n((I32 I32): 1 ) (: \"i32.rem_s\" asm ) $global.% fun\n((I64 I64): 1 ) (: \"i64.rem_s\" asm ) $global.% fun\n((F32 F32): 1 ) (: \"f32.rem\" asm ) $global.% fun\n((F64 F64): 1 ) (: \"f64.rem\" asm ) $global.% fun\n\n# Optimization for remainder 2\n((I32 I32): __is_2 ) (: a 1 \"i32.and\" asm ) $global.% fun\n((I64 I64): __is_2 ) (: a 1L \"i64.and\" asm ) $global.% fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote % ) $global.% fun\n\n\n##\n# Operator <\n##\n\n# Compare of same type\n((I32 I32): 1 ) (: \"i32.lt_s\" asm ) $global.< fun\n((I64 I64): 1 ) (: \"i64.lt_s\" asm ) $global.< fun\n((F32 F32): 1 ) (: \"f32.lt\" asm ) $global.< fun\n((F64 F64): 1 ) (: \"f64.lt\" asm ) $global.< fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote < ) $global.< fun\n\n##\n# Operator >\n##\n\n# Compare of same type\n((I32 I32): 1 ) (: \"i32.gt_s\" asm ) $global.> fun\n((I64 I64): 1 ) (: \"i64.gt_s\" asm ) $global.> fun\n((F32 F32): 1 ) (: \"f32.gt\" asm ) $global.> fun\n((F64 F64): 1 ) (: \"f64.gt\" asm ) $global.> fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote > ) $global.> fun\n\n##\n# Operator >=\n##\n\n# Compare of same type\n((I32 I32): 1 ) (: \"i32.ge_s\" asm ) $global.>= fun\n((I64 I64): 1 ) (: \"i64.ge_s\" asm ) $global.>= fun\n((F32 F32): 1 ) (: \"f32.ge\" asm ) $global.>= fun\n((F64 F64): 1 ) (: \"f64.ge\" asm ) $global.>= fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote >= ) $global.>= fun\n\n##\n# Operator <=\n##\n\n# Compare of same type\n((I32 I32): 1 ) (: \"i32.le_s\" asm ) $global.<= fun\n((I64 I64): 1 ) (: \"i64.le_s\" asm ) $global.<= fun\n((F32 F32): 1 ) (: \"f32.le\" asm ) $global.<= fun\n((F64 F64): 1 ) (: \"f64.le\" asm ) $global.<= fun\n\n# Attempt to promote values to same type\n$__can_promote ~ (: __promote <= ) $global.<= fun\n\n# Performs two operations in order\n# The results of which are stored in locals for later use out of order\n# TODO constexprs should be ignored/optimized\n(: $t =\n\tt unpack t type dup Arrow \"\" __asm\n) $seq =",
        path: pathPrefix + 'lang.phs',
    },
    'list' : {
        src: "\"./lang.phs\" require $lang =\n\n# Macro to construct a type for Linked Lists containing elements of given type\n(:  $ElemType =\n\n    # Using namespace lang within this macro\n    lang use\n\n    # Linked List with members of given type\n    ( $ListType rec:\n        ( ) type class $Nil =\n        ( ElemType ListType ) class $Node =\n    ) enum $ListType =\n\n    # Member type of the list\n    ElemType $ListType.ElemType =\n\n    # Shortcut for empty list\n    () ListType.Nil make $ListType.empty =\n\n    # Append item to list head\n    ((ElemType ListType):\n        ( $m $l ) =\n        ( m l ) ListType.Node make\n    ) $cons =\n\n    # Length of linked list\n    (:  (rec:\n            $ret =\n            (   ListType.Nil (:\n                    pop\n                    ret\n                )\n                ListType.Node (:\n                    unpack ( $v $next ) =\n                    next  ret 1 + iter\n                )\n            ) match\n        ) $iter =\n        0 iter\n    ) $ListType.length =\n\n    # Get item at specific index in list\n    \"\n    ((ListType I32):\n        (rec: ( $ll $i ) =\n            (\n                ListType.Nil (:\n\n                )\n\n            ) match\n            (: )\n        ) $iter =\n        iter\n    ) $ListType.at =\n    \" pop\n\n\n    # Apply function to each element of the list\n    (( ListType  Syntax:Macro (ElemType) (Any) Arrow | ):\n        $f =\n        (rec:\n            (   ListType.Nil (: ListType.Nil make )\n                ListType.Node (:\n                    unpack ( $v $n ) =\n                    (   v f\n                        n iter\n                    ) ListType.Node make\n                )\n            ) match\n        ) $iter =\n        iter\n    ) $ListType.map =\n\n    # Reduce list into single value starting from the left\n    # <list> <initial val> <accumulator> foldl\n    (( ListType  Any  Syntax:Macro (Any ElemType) (Any) Arrow | ):\n        $f =\n        (rec:\n            $z =\n            (   ListType.Node (:\n                    unpack ( $x $xs ) =\n                    xs\n                    z x f\n                    iter\n                )\n                ListType.Nil (: pop z )\n            ) match\n        ) $iter =\n        iter\n    ) $ListType.foldl =\n\n    # Like foldl but goes the other way around (note: not tail recursive)\n    (( ListType  Any  Syntax:Macro (ElemType Any) (Any) Arrow | ):\n        $f =\n        (rec:\n            $z =\n            (   ListType.Node (:\n                    unpack ( $x $xs ) =\n                    x\n                    xs z iter\n                        f\n                )\n                ListType.Nil (: pop z )\n            ) match\n        ) $iter =\n        iter\n    ) $ListType.foldr =\n\n    # Reverse the list\n    (( ListType ):\n        (rec: $ret =\n            (   ListType.Nil (: pop ret )\n                ListType.Node (:\n                    unpack ( $x $xs ) =\n                    xs\n                    ( x ret ) ListType.Node make\n                    iter\n                )\n            ) match\n        ) $iter =\n        () ListType.Nil make\n    ) $ListType.reverse =\n\n    (( ListType Syntax:Macro (ElemType) (I32) Arrow | ):\n        $cond =\n        (rec:\n            $ret =\n            (   ListType.Node (:\n                    unpack ( $x $xs ) =\n                    # Skip element if cond fails\n                    (: 1 ) (: xs ret iter ) $branch fun\n                    (: x cond ) (: ( x xs ret iter ) ListType.Node make )\n                )\n                ListType.Nil (: pop ret )\n            ) match\n        ) $iter =\n        iter\n    ) $ListType.filter =\n\n    # TODO take drop concat ++ elem find some\n\n    # Return the List type we created\n    ListType\n) $List =\n\n# Honestly not sure if these should be in lang ns anymore\n(( Any List Syntax:Macro (Any) (Any) Arrow | ):\n    ( $l $f ) =\n    l type $LT =\n    f type (LT.ElemType) (Any) Arrow Syntax:Macro | ==\n)\n(: ( $l $f ) = l type $ListType = l $f ~ ListType.map )\n$lang.map fun",
        path: pathPrefix + 'list.phs',
    },
    'math' : {
        src: "\"./lang.phs\"    require use\n\"./bits.phs\"    require $_bits =\n\"./number.phs\"  require $number =\n\n# Absolute value\n(: 1 ) (: $v = $v ~ ) $abs fun\n(: 0.0 < ) (: 0 swap - ) $abs fun\n((F32): 1 ) (: \"f32.abs\" asm ) $abs fun\n((F64): 1 ) (: \"f64.abs\" asm ) $abs fun\n\n# Use bigger of two values\n(: 1 ) (: pop ) $max fun\n(: < ) (: ( $a $b ) = b ) $max fun\n((F32): 1 ) (: \"f32.max\" asm ) $max fun\n((F64): 1 ) (: \"f64.max\" asm ) $max fun\n\n# Use smaller of two values\n(: 1 ) (: pop ) $min fun\n(: > ) (: ( $a $b ) = b ) $min fun\n((F32): 1 ) (: \"f32.min\" asm ) $min fun\n((F64): 1 ) (: \"f64.min\" asm ) $min fun\n\n# Square route\n((F32): 1 ) (: \"f32.sqrt\" asm ) $sqrt fun\n((F64): 1 ) (: \"f64.sqrt\" asm ) $sqrt fun\n\n# Floor\n((F32): 1 ) (: \"f32.floor\" asm ) $floor fun\n((F64): 1 ) (: \"f64.floor\" asm ) $floor fun\n\n# Ceiling\n((F32): 1 ) (: \"f32.ceil\" asm ) $ceil fun\n((F64): 1 ) (: \"f64.ceil\" asm ) $ceil fun\n\n# Truncate float\n((F32): 1 ) (: \"f32.trunc\" asm ) $trunc fun\n((F64): 1 ) (: \"f64.trunc\" asm ) $trunc fun\n\n# Nearest int ties to even\n((F32): 1 ) (: \"f32.nearest\" asm ) $nearest fun\n((F64): 1 ) (: \"f64.nearest\" asm ) $nearest fun\n\n# Clamp a value between a given min and max\n(: 1 ) (: pop pop ) $clamp fun\n(: ( $n $min $max ) = n max > ) (: $max = pop type $T = max T cast ) $clamp fun\n(: ( $n $min $max ) = n min < ) (: pop $min = type $T = min T cast ) $clamp fun\n\n# Factorial\n(: 1 ) (:\n    (rec:\n        ( $n $ret ) =\n        (: 1 ) (: n ) $branch fun\n        (: n 0 > ) (: n 1 - ret n * iter ) $branch fun\n        branch\n    ) $iter =\n    1 iter\n) $factorial fun\n\n# Raise given number to given power\n((number.Float number.Int): 1) (:\n    ( $x $n ) =\n    x type $Tf =\n\n    (: 1 ) (:\n        ((n type Tf Tf) rec: ( $n $r $l ) =\n            (: 1 ) (:       n 2 /   r       l l *   iter ) $branch fun\n            (: n 2 % ) (:   n 2 /   r l *   l l *   iter ) $branch fun\n            (: n 1 <= ) (: r l * ) $branch fun\n            branch\n        ) $iter =\n        n x 1.0 Tf cast iter\n    ) $edges fun\n    (: n 0 < ) (: 1 x -1 n - pow ) $edges fun\n    (: n 0 == ) (: 1.0 Tf cast ) $edges fun\n    edges\n) $pow fun\n\n# ** for power operator\n((number.Float number.Int): 1 ) (: pow ) $global.** fun\n((Any number.Int): $n = n is_const n 2 == && ) (: pop dup * ) $global.** fun\n\n# Some useful constants\n2.7182818284590452354   $kE =\t    # e\n1.4426950408889634074   $kLOG2E =   # log_2 e\n0.43429448190325182765  $kLOG10E =  # log_10 e\n0.69314718055994530942  $kLN2 =\t   \t# log_e 2\n2.30258509299404568402  $kLN10 =\t# log_e 10\n3.14159265358979323846  $kPI =\t   \t# pi\n\n# Log base 2\n((I32): 1 ) (: $n = 32 n _bits.clz - ) $log2 fun\n((I64): 1 ) (: $n = 64 n _bits.clz - ) $log2 fun\n((F32): 1 ) (: log kLN2 / ) $log2 fun # log_2 x = log_e x / log_e 2\n((F64): 1 ) (: log kLN2 / ) $log2 fun\n\n\" Algorithm: musl/src/math/log.c from FreeBSD\n/* log(x)\n * Return the logrithm of x\n *\n * Method :\n *   1. Argument Reduction: find k and f such that\n *                      x = 2^k * (1+f),\n *         where  sqrt(2)/2 < 1+f < sqrt(2) .\n *\n *   2. Approximation of log(1+f).\n *      Let s = f/(2+f) ; based on log(1+f) = log(1+s) - log(1-s)\n *               = 2s + 2/3 s**3 + 2/5 s**5 + .....,\n *               = 2s + s*R\n *      We use a special Remez algorithm on [0,0.1716] to generate\n *      a polynomial of degree 14 to approximate R The maximum error\n *      of this polynomial approximation is bounded by 2**-58.45. In\n *      other words,\n *                      2      4      6      8      10      12      14\n *          R(z) ~ Lg1*s +Lg2*s +Lg3*s +Lg4*s +Lg5*s  +Lg6*s  +Lg7*s\n *      (the values of Lg1 to Lg7 are listed in the program)\n *      and\n *          |      2          14          |     -58.45\n *          | Lg1*s +...+Lg7*s    -  R(z) | <= 2\n *          |                             |\n *      Note that 2s = f - s*f = f - hfsq + s*hfsq, where hfsq = f*f/2.\n *      In order to guarantee error in log below 1ulp, we compute log\n *      by\n *              log(1+f) = f - s*(f - R)        (if f is not too large)\n *              log(1+f) = f - (hfsq - s*(hfsq+R)).     (better accuracy)\n *\n *      3. Finally,  log(x) = k*ln2 + log(1+f).\n *                          = k*ln2_hi+(f-(hfsq-(s*(hfsq+R)+k*ln2_lo)))\n *         Here ln2 is split into two floating point number:\n *                      ln2_hi + ln2_lo,\n *         where n*ln2_hi is always exact for |n| < 2000.\n *\n * Special cases:\n *      log(x) is NaN with signal if x < 0 (including -INF) ;\n *      log(+INF) is +INF; log(0) is -INF with signal;\n *      log(NaN) is that NaN with no signal.\n *\n * Accuracy:\n *      according to an error analysis, the error is always less than\n *      1 ulp (unit in the last place).\n *\n * Constants:\n * The hexadecimal values are the intended ones for the following\n * constants. The decimal values may be used, provided that the\n * compiler will convert from decimal to binary accurately enough\n * to produce the hexadecimal values shown.\n */\n\" pop\n((F64): 1 ) (:\n    # Some constants\n    6.93147180369123816490e-01  $ln2_hi =   # 3fe62e42 fee00000\n    1.90821492927058770002e-10  $ln2_lo =   # 3dea39ef 35793c76\n    1.80143985094819840000e+16  $two54  =   # 43500000 00000000\n    6.666666666666735130e-01    $lg1 =      # 3FE55555 55555593\n    3.999999999940941908e-01    $lg2 =      # 3FD99999 9997FA04\n    2.857142874366239149e-01    $lg3 =      # 3FD24924 94229359\n    2.222219843214978396e-01    $lg4 =      # 3FCC71C5 1D8E78AF\n    1.818357216161805012e-01    $lg5 =      # 3FC74664 96CB03DE\n    1.531383769920937332e-01    $lg6 =      # 3FC39A09 D078C69F\n    1.479819860511658591e-01    $lg7 =      # 3FC2F112 DF3E5244\n\n    $x =\n    x _bits.reinterpret $u =\n    u 32L >> I32 cast $hx =\n\n    ((I32 F64 I64 I32):\n        ( $k $x $u $hx ) =\n\n        hx 0x3FF00000 0x3FE6A09E - + $hx2 =\n        k 0x3FF - hx2 20 >> + $k2 =\n        hx2 0x000FFFFF _bits.and 0x3FE6A09E + $hx3 =\n        hx3 _bits.zero_extend 32L << u 0xFFFFFFFFL _bits.and _bits.or $u2 =\n        u2 _bits.reinterpret $x =\n\n        x 1.0 - $f =\n        0.5 f f * * $hfsq =\n        f 2.0 f + / $s =\n        s s * $z =\n        z z * $w =\n        w lg2 w lg4 w lg6 * + * + * $t1 =\n        z lg1 w lg3 w lg5 w lg7 * + * + * + * $t2 =\n        t1 t2 + $r =\n        k2 F64 cast $dk =\n\n        s hfsq r + * dk ln2_lo * + hfsq - f + dk ln2_hi * +\n    ) $calculate =\n\n    (: 1 ) (:\n        0 x u hx\n        calculate\n    ) $edge_cases fun\n    (: hx 0x7FF00000 >= ) (: x ) $edge_cases fun\n    (: hx 0x3FF00000 == u 32L << 0L == && ) (: 0.0 ) $edge_cases fun\n    (: hx 0x00100000 < hx 31 >> || ) (:\n        (: 1 ) (:\n            -54                 # k\n            x two54 * dup       # x\n            _bits.reinterpret    # u\n            dup 32L >> I32 cast # hx\n            calculate\n        ) $branch fun\n        (: u 1L << 0L == ) (: -1.0 x x * / ) $branch fun\n        (: hx 31 >> ) (: x x - 0.0 / ) $branch fun\n        branch\n    ) $edge_cases fun\n    edge_cases\n) $log fun\n((F32): 1 ) (: F64 cast log ) $log fun\n\n# Trig Utils\n(:  ((number.Float dup): type swap type == ) (:\n        - dup type number.limits.epsilon <=\n    ) $feq fun\n    ((number.Float dup dup number.Int dup number.Float) rec:\n        ( $x $sum $n $i $s $t ) =\n        (: 1 ) (: x    sum t s * n /    n i * i 1 + *    i 2 +    s neg    t x x * *    trig_series ) $branch fun\n        (: sum sum t s * n / + feq ) (: sum ) $branch fun\n        branch\n    ) $trig_series =\n) namespace $detail =\n\n# Basic Trig functions\n((number.Float): 1 ) (:\n    dup $x = type $T =\n    x  x  6.0 T cast  4  -1  x x * x *  detail.trig_series\n) $sin fun\n((number.Float): 1 ) (:\n    dup $x = type $T =\n    x  1.0 T cast  2.0 T cast  3  -1  x x *  detail.trig_series\n) $sin fun\n((Any): 1 ) (: $x = x sin  x cos / ) $tan fun\n((Any): 1 ) (: $x = x cos  x sin / ) $cot fun\n((Any): 1 ) (: $x = 1 x cos / ) $sec fun\n((Any): 1 ) (: $x = 1 x sin / ) $csc fun\n",
        path: pathPrefix + 'math.phs',
    },
    'maybe' : {
        src: "\"./lang.phs\" require use\n\n(:  $T =\n    (:  () type class $Nothing =\n        T class $Just =\n    ) enum\n) $Maybe =\n\nAny Maybe $AnyMaybe =\n\n# Bind calls a function on a Just value\n# If given Nothing returns Nothing instead\n(( Any Maybe  Syntax:Macro (Any) (Any Maybe) Arrow | ): 1 ) (:\n    $f =\n    dup type $TMaybe =\n    (   TMaybe.Nothing (: pop () TMaybe.Nothing make )\n        TMaybe.Just (: f )\n    ) match\n) $bind fun\n\n# Invokes v when given nothing, otherwise returns given value\n(( Any Maybe dup Syntax:Macro () type (Any Maybe) Arrow | | ): 1 ) (:\n    $v =\n    dup type $TMaybe =\n    (   TMaybe.Nothing (: v )\n        TMaybe ((TMaybe)(TMaybe): )\n    ) match\n) $fails fun",
        path: pathPrefix + 'maybe.phs',
    },
    'mem' : {
        src: "\"./lang.phs\" require use\n\"./bits.phs\" require $bits =\n\n((F32 I32): 1 ) (:\n    swap \"i32.reinterpret_f32\" asm swap\n    static_init\n) $static_init fun\n((F64 I32): 1 ) (:\n    swap \"i64.reinterpret_f64\" asm swap\n    static_init\n) $static_init fun\n((I64 I32): 1 ) (:\n    ( $v $addr ) =\n    # Initialize upper\n    v 0xffffffffL and \"i32.wrap_i64\" asm addr static_init\n\n    # Initialize lower\n    v 32L >> \"i32.wrap_i64\" asm addr 4 + static_init\n) $static_init fun\n((I32 I32): 1 ) (:\n    ( $v $addr ) =\n    # NOTE little endian\n    v 0xff and\n        addr static_init_byte\n    v 8 >> 0xff and\n        addr 1 + static_init_byte\n    v 16 >> 0xff and\n        addr 2 + static_init_byte\n    v 24 >> 0xff and\n        addr 3 + static_init_byte\n) $static_init fun\n\n# Store value in memory\n# <unit> <value> <addr> store\n((Unit I32 I32): 1 ) (:\n    swap ( Unit I32 I32 ) ( Unit ) Arrow \"i32.store\" __asm\n) $store fun\n((Unit F32 I32): 1 ) (:\n    swap ( Unit I32 F32 ) ( Unit ) Arrow \"f32.store\" __asm\n) $store fun\n((Unit I64 I32): 1 ) (:\n    swap ( Unit I32 I64 ) ( Unit ) Arrow \"i64.store\" __asm\n) $store fun\n((Unit F64 I32): 1 ) (:\n    swap ( Unit I32 F64 ) ( Unit ) Arrow \"f64.store\" __asm\n) $store fun\n\n# Load value from memory\n# <unit> <I32 addr> <TYPE> load\n((I32 Syntax:Type): I32 == ) (: pop \"i32.load\" asm ) $load fun\n((I32 Syntax:Type): I64 == ) (: pop \"i64.load\" asm ) $load fun\n((I32 Syntax:Type): F32 == ) (: pop \"f32.load\" asm ) $load fun\n((I32 Syntax:Type): F64 == ) (: pop \"f64.load\" asm ) $load fun\n\n# Byte width of type\n# ... this prob should be part of compiler...\n# <type> sizeof -- <byte width>\n((Syntax:Type): I32 == ) (: pop 4 ) $sizeof fun\n((I32): 1 ) (: pop 4 ) $sizeof fun\n((Syntax:Type): F32 == ) (: pop 4 ) $sizeof fun\n((F32): 1 ) (: pop 4 ) $sizeof fun\n((Syntax:Type): I64 == ) (: pop 8 ) $sizeof fun\n((I64): 1 ) (: pop 8 ) $sizeof fun\n((Syntax:Type): F64 == ) (: pop 8 ) $sizeof fun\n((F64): 1 ) (: pop 8 ) $sizeof fun\n\n\n\n# TODO dynamic memory allocation and use\n# We have ability to allocate arbitrary blocks of memory via $__alloc but\n#  how do we initialize it in a functional way?\n\n((I32 I32 Syntax:Type): ( $size $ref_bf_addr $Type ) =\n    size 8 / ref_bf_addr\n    ( I32 I32 ) ( Type rec )\n    \"(call $__alloc)(call $__ref_stack_push)\" __asm\n) $alloc =\n\n((I32 Syntax:Str):\n    # Store string literal bf into static memory\n    $bf_str = bf_str swap pop alloc\n) $alloc =\n\n# Copy an object into the a gc-managed space\n(:  $v =\n    # Get reference bitfield\n    v type $Type =\n    Type __gc_ref_bf $ref_bf =\n    ref_bf ( $bf_len $bf_addr ) =\n\n    # Allocate space for object on heap\n    bf_len 2 >>  bf_addr\n    ( Unit I32 I32 ) ( Unit )\n    \"(call $__alloc)(call $__ref_stack_push)\" __asm\n\n    ( Unit ) ( I32 )\n    \"\"\n) $to_gc =\n",
        path: pathPrefix + 'mem.phs',
    },
    'monad' : {
        src: "\"./lang.phs\" require use\n\n# These 'monads' rly do be cucked ngl\n\n# Cucked io monad alternative\n(: $T = T ) class $Monad =\n\n# These operators exist only such that we can do operations involving various monad types\n# TODO should probably check if they're truthy\n(: 1 )\n(((Any Monad) (Any Monad) Arrow (Any Monad) (Any Monad) Arrow):\n    ( $a $b ) =\n    ((Any Monad) (Any Monad): $m = ( m a b ) seq )  # TODO seq does nothing here???\n) $global.>> fun",
        path: pathPrefix + 'monad.phs',
    },
    'number' : {
        src: "\"./lang.phs\" require use\n\n# Some number types\nI32 I64 | $Int =\nF32 F64 | $Float =\nInt Float | $Num =\n\n# Numeric limits\n(:  # F64\n    ((Syntax:Type): F64 == ) (: pop 2.220446049250313e-16 ) $epsilon fun\n    ((Syntax:Type): F64 == ) (: pop 5e-324 ) $min fun\n    ((Syntax:Type): F64 == ) (: pop 1.7976931348623157e+308 ) $max fun\n    ((Syntax:Type): F64 == ) (: pop -9007199254740991L ) $min_safe_int fun\n    ((Syntax:Type): F64 == ) (: pop 9007199254740991L ) $min_safe_int fun\n    ((Syntax:Type): F64 == ) (: pop NaN ) $nan fun\n    ((Syntax:Type): F64 == ) (: pop Infinity ) $pos_inf fun\n    ((Syntax:Type): F64 == ) (: pop -Infinity ) $neg_inf fun\n\n    # F32\n    ((Syntax:Type): F32 == ) (: pop 1.19209289550781e-07f ) $epsilon fun\n    ((Syntax:Type): F32 == ) (: pop 1.17549435082229e-38f ) $min fun\n    #((Syntax:Type): F32 == ) (: pop 1.7976931348623157e+308 ) $max fun\n    #((Syntax:Type): F32 == ) (: pop -9007199254740991L ) $min_safe_int fun\n    #((Syntax:Type): F32 == ) (: pop 9007199254740991 ) $min_safe_int fun\n    ((Syntax:Type): F32 == ) (: pop NaN F32 cast ) $nan fun\n    ((Syntax:Type): F32 == ) (: pop Infinity F32 cast ) $pos_inf fun\n    ((Syntax:Type): F32 == ) (: pop -Infinity F32 cast ) $neg_inf fun\n\n    # I32\n    ((Syntax:Type): I32 == ) (: pop 0xFFFFFFFF ) $max fun\n    ((Syntax:Type): I32 == ) (: pop 0 ) $min fun\n\n    # I64\n    ((Syntax:Type): I64 == ) (: pop 0xFFFFFFFFFFFFFFFFL ) $max fun\n    ((Syntax:Type): I64 == ) (: pop 0 ) $min fun\n) namespace $limits =\n\n# Some utilities for unsigned integers\n# TODO Probably should add builtin unsigned types\n(:\n    # Like prelude.cast but uses unsigned int types instead\n    ((F32 Syntax:Type): I32 == ) (: \"i32.trunc_f32_u\" asm ) $convert fun\n    ((F32 Syntax:Type): I64 == ) (: \"i64.trunc_f32_u\" asm ) $convert fun\n    ((F64 Syntax:Type): I32 == ) (: \"i32.trunc_f64_u\" asm ) $convert fun\n    ((F64 Syntax:Type): I64 == ) (: \"i64.trunc_f64_u\" asm ) $convert fun\n    ((I32 Syntax:Type): F32 == ) (: \"f32.convert_i32_u\" asm ) $convert fun\n    ((I32 Syntax:Type): F64 == ) (: \"f64.convert_i32_u\" asm ) $convert fun\n    ((I64 Syntax:Type): F32 == ) (: \"f32.convert_i64_u\" asm ) $convert fun\n    ((I64 Syntax:Type): F64 == ) (: \"f64.convert_i64_u\" asm ) $convert fun\n) namespace $unsigned =",
        path: pathPrefix + 'number.phs',
    },
    'str' : {
        src: "\"./lang.phs\" require $lang =\n\"./list.phs\" require \"List\" \"\" use_some\n\n# Make concatenate string literals\n((Syntax:Str Syntax:Str): 1 ) (:\n    # I just wasted 2 mins making this lol\n    \"(() => {\n        const b = ctx.pop().value;\n        const v = ctx.pop().value + b;\n        ctx.push(new value.StrValue(token, v));\n    })()\" :eval\n) $global.+ fun\n\n# String class\n( I32 I32 ) class $StaticStr =\n((StaticStr): 1 ) (: unpack lang.pop ) $size fun\n((StaticStr): 1 ) (: unpack lang.swap lang.pop ) $addr fun\n\n# Overload cast operator to convert static string literals\n((Syntax:Str Syntax:Type): StaticStr == ) (:\n    pop $lit =\n    ( lit ) StaticStr make\n) $lang.cast fun\n\n# Characters are stored in I32's for performance reasons\nI32 $Char =\n\n# Strings could be represented as a list of characters\n# But generally this wouldn't be ideal in terms of performance\n# For this reason we give it a somewhat obscure name\n# And define a better default string implementation later on\nChar List $ListStr =\n\n# TODO implement strings similar to Haskell's Data.Text\n\n# Type for strings generated at runtime\n( I32 I32 ) class $Str =\n((Str): 1 ) (: unpack lang.pop ) $size fun\n((Str): 1 ) (: unpack lang.swap lang.pop ) $addr fun\n\n(( StaticStr Str | lang.dup ): 1 ) (:\n    ( $lhs $rhs ) =\n    # TODO\n) $concat fun",
        path: pathPrefix + 'str.phs',
    },
};